/* Static structures for codegen.c.
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct upu {
  ExprPtr vn;
  ExprPtr vf;
  ExprPtr deco;
};

struct outzap {
  outFiles *of;
  CHAR *msg;
};

struct getvarnames {
  ExprPtr x;
  ExprPtr deco;
  ExprPtr vn,vf;
  MapPtr frontier;
  ExprPtr last;
};

struct splitcode {
  ExprPtr x;
  ExprPtr last;
  ExprPtr runlast,initlast;
  ExprPtr deco;
  ExprPtr ideco;
  MapPtr ieqns;
  CHAR *funcname;
  MapPtr done;
};

struct outputcode {
  ExprPtr x,last;
  ExprPtr c;
  ExprPtr vn;
  CHAR *modulename;
  outFiles *of;
  MapPtr done;
};
