/* Static structures for eval.c.
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct vectormatch {
  ExprPtr arg;
  ExprPtr pat,val;
  COUNTER idx;
  Boolean res;
};

struct matchvalue {
  ExprPtr arg;
  ExprPtr pat,val;
  Boolean res;
};

struct mapadd_match {
  ExprPtr maplet,rest;
  ExprPtr val;
  ExprPtr savePatChoiceBody;
  ExprPtr env;
};

struct evalbinding1 {
  ExprPtr binding;
  ExprPtr env;
  Boolean res;
};


struct evaldomsim {
  ExprPtr domains;
  ExprPtr saveenv;
  ExprPtr locals;
};

struct evalsimpleof {
  ExprPtr neutral;
  ExprPtr (*combine) P((ExprPtr e1,ExprPtr e2));
  ExprPtr (*promote) P((ExprPtr e));
  ExprPtr dompats;
  ExprPtr domains;
  ExprPtr locals;
  ExprPtr pat;
  ExprPtr f,p;
  ExprPtr saveenv;
  Boolean mapsweep;
};

DECL_ACTION(apply_polyfun_closure)
