
datatype funtree = FT_NIL
       | FT_OF of funtree option * (string -m> funtree);

fun iter (FT_OF (ftopt, ftmap), acc) =
    ((case ftopt of
	  SOME ft => iter (ft, NONE::acc) (* if this branch is executed, then the
					   iterate loop below is skipped (problem in
					   detecting tail-recursion?) *)
	| _ => ());
	  iterate
	    iter (funt, SOME s::acc)
	  | s => funt in map ftmap
	  end)
  | iter (FT_NIL, acc) = print stderr (pack (rev acc));

val ft = FT_OF (SOME (FT_OF (NONE,{"2" => FT_NIL})),
		{"y" => FT_OF (NONE,{"address" => FT_NIL}),
		  "main_return"
		  => FT_OF (NONE,{"0" => FT_NIL}),
		  "x1" => FT_OF (NONE,{"4" => FT_NIL}),
		  "x" => FT_OF (NONE,{"4" => FT_NIL}),
		  "x3" => FT_OF (NONE,{"2" => FT_NIL})});

iter (ft, nil);
#put stderr "\n";
#flush stderr ();
