/* Bytecode interpreter support functions, headers.
   Copyright (C) 2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

IMPORT void mergeFieldLists P((INOUT ExprPtr *fields1,
			       INOUT ExprPtr *fields2,
			       OUT ExprPtr *newfields,
			       IN INT m,
			       IN INT n,
			       OUT INT *np));
IMPORT void dumpShape P((IN CONST ExprPtr shape,
			 OUT ExprPtr *fields));
IMPORT MapPtr undumpShape P((IN CONST ExprPtr *fields,
			     IN INT n));
IMPORT ExprPtr Kmu1 P((IN CONST ExprPtr rec,
		       IN CONST ExprPtr modlab,
		       IN CONST ExprPtr modval));
IMPORT ExprPtr Mu1 P((IN CONST ExprPtr rec,
		      IN CONST ExprPtr modlab,
		      IN CONST ExprPtr modval));
IMPORT ExprPtr KmuGnrl P((IN CONST ExprPtr rec,
			  IN CONST ExprPtr mod));
IMPORT ExprPtr MuGnrl P((IN CONST ExprPtr rec,
			 IN CONST ExprPtr mod));
IMPORT ExprPtr envCons P((IN REGISTER COUNTER n,
			  IN CONST ExprPtr env));
IMPORT ExprPtr QueueToList P((IN ExprPtr queue));
IMPORT ExprPtr ListToQueue P((IN CONST ExprPtr list));
IMPORT Boolean do_initialsubmap P((IN CONST ExprPtr x,IN CONST ExprPtr y,
				   INOUT CHAR *_data));
DECL_ACTION(datacon_shared)
IMPORT void resetHandlerStack P((void));
IMPORT void setHandlerStack P((IN CONST excHandler *stack));
