(* church integers *)

    fun succ n = n+1;
	
    fun double f = fn x => f(f x);

    val quad = double double;

    fun interval n =
	if n <= 0 then [] else n :: interval (n-1);

    fun map f = let fun map_rec  [] = []
		      | map_rec (a::L) = f a :: map_rec L
		in map_rec end;

    fun main x = (map (quad quad succ) (interval 10000); ());
			
