(* division euclidienne *)
 

datatype nat =  O_C |  S_C of nat;
datatype ('B,'A) prod =  pair_C of 'A * 'B;
datatype sumbool =  left_C |  right_C;
datatype 'A sumor =  inleft_C of 'A |  inright_C;
fun fst u = (fn (pair_C (VAR3,VAR4)) => VAR3) u;
fun snd u = (fn (pair_C (VAR3,VAR4)) => VAR4) u;
 

exception failure of string;

fun fail () = raise (failure "fail");
 

fun le_or_gt n =
 let fun VAR1 VAR2 =
  case VAR2 of
     O_C => (fn m => left_C)
   | S_C VAR3 =>
       fn m =>
             case m of
                O_C => right_C
              | S_C VAR3' =>
                  case VAR1 VAR3 VAR3' of
                     left_C => left_C | right_C => right_C in
  VAR1 n end;
 

fun O_or_S n =
 case n of O_C => inright_C | S_C VAR3 => inleft_C VAR3;
 

fun le_or_s n =
 let fun VAR1 VAR2 =
  case VAR2 of
     O_C => (fn m => left_C)
   | S_C VAR3 =>
       fn m =>
             case m of
                O_C => right_C
              | S_C VAR3' =>
                  case VAR1 VAR3 VAR3' of
                     left_C => left_C | right_C => right_C in
  VAR1 n end;
 

fun gt_S_s n m =
 case le_or_gt n m of
    left_C =>
      (case le_or_s m n of left_C => right_C | right_C => fail())
  | right_C => left_C;
 

fun division_extractible n d =
 let fun VAR1 VAR2 =
  case VAR2 of
     O_C => pair_C (O_C,O_C)
   | S_C VAR3 =>
       case d of
          O_C =>
            (case fail () of
                left_C => pair_C (fst (VAR1 VAR3),S_C (snd (VAR1
VAR3)))
              | right_C => pair_C (S_C (fst (VAR1 VAR3)),O_C))
        | S_C VAR3' =>
            case gt_S_s VAR3' (snd (VAR1 VAR3)) of
               left_C => pair_C (fst (VAR1 VAR3),S_C (snd (VAR1
VAR3)))
             | right_C => pair_C (S_C (fst (VAR1 VAR3)),O_C) in
  VAR1 n end;
 
val UN = S_C O_C;
 

val DEUX = S_C UN;
 

val TROIS = S_C DEUX;
 

fun PLUS n p = case p of O_C => n | (S_C m) => (S_C (PLUS n m));
 

val SIX = PLUS TROIS TROIS;
 

val DOUZE = PLUS SIX SIX;
 

fun print_nat O_C = #put stdout "0"

 |  print_nat (S_C n) = (#put stdout "S " ;print_nat n);

fun print_resultat (pair_C (a,b)) = (print_nat a; #put stdout "-->"; print_nat b);

fun main x = (print_resultat (division_extractible DOUZE DOUZE);#put stdout "\n");
