/* Static structures for optimize.c.
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct fundata {
  INT storage;
  INT fxtypes;
  CHAR tags[NTAGS];
};

struct newuse {
  ExprPtr stmt;
  ExprPtr deco;
};

struct newusek {
  ExprPtr stmt;
  ExprPtr use;
  ExprPtr deco;
  Boolean res;
};

struct nxprod {
  ncrossFunc fun;
  char *data;
  COUNTER pos[2];
  COUNTER npos;
  ExprPtr *args;
  INT n;
};

struct getdestroyed_known {
  ExprPtr def;
  ExprPtr deco;
};

struct getdestroyed {
  COUNTER fxtypes;
  ExprPtr deco;
};

struct readmapget {
  COUNTER found;
  MapPtr mapvalset;
  ExprPtr x;
  ExprPtr deco;
  MapPtr eqns;
};

struct ppdecomerge {
  Boolean changed;
  ExprPtr info;
  ExprPtr deco;
  ExprPtr merge;
};

struct ppdecok {
  ExprPtr x;
  ExprPtr last;
  ExprPtr deco;
  MapPtr fragile;
  MapPtr eqns;
  MapPtr frontier;
};

struct countfrontier {
  int n;
  ExprPtr deco;
};

struct getfrontier {
  int n;
  MapPtr nodes;
  ExprPtr deco;
};

struct remove_merge {
  ExprPtr deco;
  ExprPtr merge;
};

struct pppatch {
  ExprPtr x;
  ExprPtr deco;
  ExprPtr last;
  Boolean res;
};

struct copycode {
  ExprPtr x;
  ExprPtr inlast;
  ExprPtr outlast;
  MapPtr initvars;
  MapPtr vars;
};

struct unarymerge_p {
  INT tag;
  ExprPtr deco;
};

struct unarymerge {
  ExprPtr outlast;
};

struct pppatch1 {
  ExprPtr x;
  ExprPtr deco;
  MapPtr rem;
  ExprPtr handlers;
  MapPtr last;
  Boolean res;
};

struct todeforest {
  ExprPtr x;
  ExprPtr deco;
  ExprPtr last;
  MapPtr vars;
};

struct deforest {
  ExprPtr deco;
  MapPtr vars;
};

struct frontiercmp {
  ExprPtr last;
  ExprPtr vars;
};

struct build_ivars {
  ExprPtr newvar;
  ExprPtr deco;
};
